//
//  RCConversationViewController+bottomBar.m
//  RongIMKit_Demo
//
//  Created by Jue on 2021/9/16.
//  Copyright © 2021 RC. All rights reserved.
//

#import "RCConversationViewController+bottomBar.h"
#import <objc/runtime.h>

@implementation RCConversationViewController (bottomBar)

+(void)load {
    //只执行一次这个方法
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        
        //替换 viewWillAppear
        NSString *oldSelStr1 = @"viewWillAppear:";
        NSString *newSelStr1 = @"viewWillAppearAddBottomBar:";
        [self.class exchangeInstanceMethodWithSelfClass:self originalSelector:NSSelectorFromString(oldSelStr1) swizzledSelector:NSSelectorFromString(newSelStr1)];
        
        //替换 chatInputBar:shouldChangeFrame:
        NSString *oldSelStr = @"chatInputBar:shouldChangeFrame:";
        NSString *newSelStr = @"chatInputBarAddBottomBar:shouldChangeFrame:";
        [self.class exchangeInstanceMethodWithSelfClass:self originalSelector:NSSelectorFromString(oldSelStr) swizzledSelector:NSSelectorFromString(newSelStr)];
    });
}


// 让 bottomBarView 随着输入框的 frame 变化而变化
- (void)chatInputBarAddBottomBar:(RCChatSessionInputBarControl *)chatInputBar shouldChangeFrame:(CGRect)frame{
    CGRect chatSessionBarFrame = self.chatSessionInputBarControl.frame;
    [self chatInputBarAddBottomBar:chatInputBar shouldChangeFrame:frame];
    if (!self.bottomBarView) {
        self.bottomBarView = [UIView new];
        [self.bottomBarView setBackgroundColor:[UIColor redColor]];
        [self.view addSubview:self.bottomBarView];
    }
    self.bottomBarView.frame = CGRectMake(0, chatSessionBarFrame.origin.y + chatSessionBarFrame.size.height , chatSessionBarFrame.size.width, HIGH_BOTTOMBAR);
}

- (void)viewWillAppearAddBottomBar:(BOOL)animated {
    [self viewWillAppearAddBottomBar:animated];
    CGRect frame = self.conversationMessageCollectionView.frame;
    frame.size.height -= HIGH_BOTTOMBAR;
    self.conversationMessageCollectionView.frame = frame;
    [self scrollToBottomAnimated:NO];
}

// 交换
+ (void)exchangeInstanceMethodWithSelfClass:(Class)selfClass
                          originalSelector:(SEL)originalSelector
                          swizzledSelector:(SEL)swizzledSelector {
   
   Method originalMethod = class_getInstanceMethod(selfClass, originalSelector);
   Method swizzledMethod = class_getInstanceMethod(selfClass, swizzledSelector);
   BOOL didAddMethod = class_addMethod(selfClass,
                                       originalSelector,
                                       method_getImplementation(swizzledMethod),
                                       method_getTypeEncoding(swizzledMethod));
   if (didAddMethod) {
       class_replaceMethod(selfClass,
                           swizzledSelector,
                           method_getImplementation(originalMethod),
                           method_getTypeEncoding(originalMethod));
   } else {
       method_exchangeImplementations(originalMethod, swizzledMethod);
   }
}

// setBottomBarView 的 set 和 get 方法
- (void)setBottomBarView:(UIView *)bottomBarView{
    objc_setAssociatedObject(self, @selector(bottomBarView), bottomBarView, OBJC_ASSOCIATION_RETAIN_NONATOMIC);
}
- (UIView *)bottomBarView {
    return objc_getAssociatedObject(self, @selector(bottomBarView));
}





@end
